<script setup lang="ts">
import FormWithoutButton from "@/components/atoms/form/FormWithoutButton.vue";
import AutoComplete, {AutoCompleteCompleteEvent} from "primevue/autocomplete";
import ColumnInputGroup from "@/components/molecules/form/ColumnInputGroup.vue";
import InputText from "primevue/inputtext";
import {onMounted, ref, watch} from "vue";
import {BasedCode} from "@/entities/BasedCode/BasedCode";
import {useBasedCodeListStore} from "@/stores/BasedCode/BasedCodeListStore";
import type Repository from "@/entities/Repository/Repository";
import {RepositoryApiHandler} from "@/handlers/RepositoryApiHandler";
import {useSnackbarStore} from "@/stores/Snackbar/SnackbarStore";

const props = defineProps<{
  afterSubmitCallback?: Function
}>()

const basedCodeList = useBasedCodeListStore();
const snackbarStore = useSnackbarStore();

const submit = defineModel('submit');
const host = defineModel<String | null>('host');
const token = defineModel<string>('token');
const basedCode = defineModel<BasedCode>('basedCode');
const repositories = defineModel<Array<Repository>>('repositories');

const form = ref();

const filteredBasedCodes = ref<Array<BasedCode>>([]);

const search = (event: AutoCompleteCompleteEvent) => {
  filteredBasedCodes.value = basedCodeList.basedCodes.filter((basedCode: BasedCode) => basedCode.name.toLowerCase().includes(event.query.toLowerCase()));
}

watch(submit, (newSubmit: Boolean) => {
  if (newSubmit) {
    form.value.executeSubmit();
  }
})

const onSubmit = () => {
  const tokenValue = token.value;

  if(!tokenValue){
    return;
  }

  const basedCodeValue = basedCode.value;

  if(!basedCodeValue){
    return;
  }

  const repositoryHandler = new RepositoryApiHandler();
  repositoryHandler.getRepositoriesFromBasedCode(basedCodeValue, tokenValue, host.value ?? null)
      .then((foundRepositories: Array<Repository>) => {
        repositories.value = foundRepositories;
        props?.afterSubmitCallback();
      }).catch(snackbarStore.createMessagesFromError);
}

onMounted(() => basedCodeList.init())
</script>

<template>
  <FormWithoutButton :onSubmit="onSubmit" :onFailedSubmit="() => submit = false" ref="form">
    <ColumnInputGroup label="Type de dépôt :" id="basedCode">
      <AutoComplete
          v-model="basedCode"
          dropdown
          :suggestions="filteredBasedCodes"
          @complete="search"
          :aria-required="true"
          inputId="basedCode"
          optionLabel="name"
          :inputProps="{required: true, name: 'basedCode'}"
      />
    </ColumnInputGroup>
    <ColumnInputGroup
        label="Token :"
        id="token"
    >
      <InputText id="token" v-model="token" required/>
    </ColumnInputGroup>
    <ColumnInputGroup
        label="Host :"
        id="host"
    >
      <InputText id="host" v-model="host"/>
    </ColumnInputGroup>
  </FormWithoutButton>
</template>
